//This deals with the standard HUD for most WipeKart Modes

//1.0.1 sucks. Check to see if it's not 1.0.1 or earlier
//1.0.2 also sucks, because it doesn't have the freeplay hud editing!

local hudstatus = CV_RegisterVar({
	name = "wipekart_hud",
	defaultvalue = "On",
	flags = 0,
	possiblevalue = CV_OnOff
})

local function goodver()
	return not (VERSIONSTRING == "v1.0.2" or VERSIONSTRING == "v1.0.1" or VERSIONSTRING == "v1.0.0")
end

local function topPlaceText(place)
	if place == 1 then return "1ST" end
	if place == 2 then return "2ND" end
	if place == 3 then return "3RD" end
	return place .. "TH"
end

local function wipehud_place(v, p, splitx, splity)
	-- random stuff for taking damage:
	local rx, ry = 0, 0
	if p.mo.zhudshake
		rx = N_RandomRange(-4, 4)
		ry = N_RandomRange(-4, 4)	-- shaker for damage
	end
	
	if hud.enabled("position") then hud.disable("position") end
	if goodver() then
		if hud.enabled("freeplay") then hud.disable("freeplay") end
	end
	local placetext = topPlaceText(p.kartstuff[k_position])
	local x = 315
	local y = 177
	local flags = V_HUDTRANS
	if not splity then
		flags = $|V_SNAPTOBOTTOM|V_SNAPTORIGHT
	else
		if splity == 2 then
			flags = $|V_SNAPTOBOTTOM
		else
			y = $ - 100
		end
		if splitx == 2 then
			flags = $|V_SNAPTORIGHT
		elseif splitx == 1 then
			x = $ - 160
		end
	end
	drawWipeFontString(v, "WOFNT", placetext, x+rx, y+ry, 14, flags)
end

local function padTimerZero(num)
	if num < 10
		return "0" .. tostring(num)
	else
		return tostring(num)
	end
end

local function ticsToTimer(num)
	return padTimerZero(G_TicsToMinutes(num, true)) .. ":" ..  padTimerZero(G_TicsToSeconds(num)) .. "." .. padTimerZero(G_TicsToCentiseconds(num))
end

local function wipehud_time(v, p, splitx, splity)
	-- random stuff for taking damage:
	local rx, ry = 0, 0
	if p.mo.zhudshake
		rx = N_RandomRange(-4, 4)
		ry = N_RandomRange(-4, 4)	-- shaker for damage
	end
	
	if hud.enabled("time") then hud.disable("time") end
	local time = p.realtime
	if (gametype & GT_MATCH) then
		local timelimit
		if server.deli_timelimit then 
			timelimit = server.deli_timelimit
		else
			timelimit = CV_FindVar("timelimit").value
		end
		if timelimit then time = max((timelimit * 60 * TICRATE) - $, 0)
	end
	
	local timestring = ticsToTimer(time)
	local timeflags = V_HUDTRANS
	local x = 6
	local y = 6
	if not splity then
		timeflags = $|V_SNAPTOTOP|V_SNAPTOLEFT
	else
		if splity == 1 then
			timeflags = $|V_SNAPTOTOP
		else
			y = $ + 100
		end
		if splitx == 1 then
			timeflags = $|V_SNAPTOLEFT
		elseif splitx == 2 then 
			x = $ + 160
		end
	end
	if splitx then
		v.drawString(x + rx, y + ry , timestring, timeflags, "left")
	else
		if bombred then
			drawWipeFontString(v, "WRFNT", timestring, x+rx, y+ry, 14, timeflags, true)
		else
			drawWipeFontString(v, "WOFNT", timestring, x+rx, y+ry, 14, timeflags, true)
		end
	end
end

local function wipehud_laps(v, p, split, splitx, splity)
	-- random stuff for taking damage:
	local rx, ry = 0, 0
	if p.mo.zhudshake
		rx = N_RandomRange(-4, 4)
		ry = N_RandomRange(-4, 4)	-- shaker for damage
	end
	
	if hud.enabled("gametypeinfo") then hud.disable("gametypeinfo") end
	local currentlap = p.laps + 1
	if p.laps == numlaps then currentlap = p.laps end
	local x = 311
	local y = 6
	local flags = V_HUDTRANS
	if not splity then
		flags = $|V_SNAPTOTOP|V_SNAPTORIGHT
	else
		if splity == 1 then
			flags = $|V_SNAPTOTOP
		else
			y = $ + 100
		end
		if splitx ~= 1 then
			flags = $|V_SNAPTORIGHT
		else
			x = $ - 160
		end
	end
	local lapstring = "LAP "..padTimerZero(currentlap)
	if currentlap > 99 then lapstring = "LAP XX" end
	drawWipeFontString(v, "WOFNT", lapstring, x+rx, y+ry, 14, flags)
	if (not splitx) and (not modeattacking) then
		lapstring = "OF "..padTimerZero(numlaps)
		drawWipeFontString(v, "WOFNT", lapstring, x+rx, y+ry+20, 14, flags)
	end
	
	
	if p.wipeout and not split and (numlaps <= 8) then
		local currentlaptime = p.realtime
		local colorflag
		for a = 1, numlaps
			if p.mo.zhudshake
				rx = N_RandomRange(-4, 4)
				ry = N_RandomRange(-4, 4)	-- shaker for damage
			end
			if a > currentlap then
				v.drawString(311 + rx, 46 + ry + ((a - 1) * 9), "L" .. a .. " - 00:00.00", V_PURPLEMAP|V_HUDTRANSHALF|V_SNAPTOTOP|V_SNAPTORIGHT, "right")
			elseif p.wipeout.laptime[a] then
				currentlaptime = $ - p.wipeout.laptime[a]
				if a == p.wipeout.bestlap then
					colorflag = V_YELLOWMAP
				else
					colorflag = 0
				end
				v.drawString(311 + rx, 46 + ry + ((a - 1) * 9), "L" .. a .. " - " .. ticsToTimer(p.wipeout.laptime[a]), colorflag|V_HUDTRANSHALF|V_SNAPTOTOP|V_SNAPTORIGHT, "right")
			elseif a == currentlap
				colorflag = V_BLUEMAP
				v.drawString(311 + rx, 46 + ry + ((a - 1) * 9), "L" .. a .. " - " ..ticsToTimer(currentlaptime), colorflag|V_HUDTRANSHALF|V_SNAPTOTOP|V_SNAPTORIGHT, "right")
			end
		end
	end
end

local function splititemmod(x, y, splitx, splity)
	if splity then
		y = $ + (100 * (splity - 1)) + 48
		if splitx then
			x = $ - (((3 - (2 * splitx)) * 80) + 66)
		else
			x = $ - 146
		end
	end
	return x, y
end

local function wipehud_item(v, p, splitx, splity)
	-- random stuff for taking damage:
	local rx, ry = 0, 0
	if p.mo.zhudshake
		rx = N_RandomRange(-4, 4)
		ry = N_RandomRange(-4, 4)	-- shaker for damage
	end
	local x = 160
	local y = 10
	x, y = splititemmod(x, y, splitx, splity)
	local flags = V_HUDTRANS
	if not splity then
		flags = $|V_SNAPTOTOP
	else
		if splity == 2 then
			flags = $|V_SNAPTOBOTTOM
		end
		if splitx ~= 2 then
			flags = $|V_SNAPTOLEFT
		end
	end
	
	//These item patches would have their origin set at the top middle of the hexagon
	if hud.enabled("item") then hud.disable("item") end
	local patch
	if p.kartstuff[k_invincibilitytimer] > 0 then
		local invtimes = p.kartstuff[k_invincibilitytimer] / TICRATE
		local invtimeds = ((p.kartstuff[k_invincibilitytimer]%TICRATE)*10)/TICRATE
		if (p.kartstuff[k_invincibilitytimer] % 6) >= 3 or (p.kartstuff[k_invincibilitytimer] >= (TICRATE*2)) then
			patch = v.cachePatch("W_IAUTOU")
		else
			patch = v.cachePatch("W_IUSEFL")
		end
		v.draw(rx+x, ry+y, patch, flags)
		v.drawString(rx+x, ry+y+32, invtimes.."."..invtimeds, flags|(((invtimes >= 2) or ((p.kartstuff[k_invincibilitytimer] % 6) >= 3)) and V_GREENMAP or V_REDMAP) , "center")
	elseif p.kartstuff[k_growshrinktimer] > 0 then
		local growtimes = p.kartstuff[k_growshrinktimer] / TICRATE
		local growtimeds = ((p.kartstuff[k_growshrinktimer]%TICRATE)*10)/TICRATE
		if (p.kartstuff[k_growshrinktimer] % 6) >= 3 then
			patch = v.cachePatch("W_IGROWU")
		else
			patch = v.cachePatch("W_IUSEFL")
		end
		v.draw(rx+x, ry+y, patch, flags)
		v.drawString(rx+x, ry+y+32, growtimes.."."..growtimeds, flags|(((growtimes >= 2) or ((p.kartstuff[k_growshrinktimer] % 6) >= 3)) and V_BLUEMAP or V_REDMAP), "center")
	elseif p.kartstuff[k_rocketsneakertimer] > 0 then
		local rockettimes = p.kartstuff[k_rocketsneakertimer] / (TICRATE*2)
		local rockettimeds = ((p.kartstuff[k_rocketsneakertimer]%(TICRATE*2))*10)/(TICRATE*2)
		if ((p.kartstuff[k_rocketsneakertimer] % 12) >= 6) or (rockettimes >= 3) then
			patch = v.cachePatch("W_ITRENU")
		else
			patch = v.cachePatch("W_IUSEFL")
		end
		v.draw(rx+x, ry+y, patch, flags)
		v.drawString(rx+x, ry+y+32, rockettimes.."."..rockettimeds, flags|(((rockettimes >= 3) or ((p.kartstuff[k_rocketsneakertimer]%6) >= 3)) and V_YELLOWMAP or V_REDMAP), "center")
	elseif tonumber(p.kartstuff[k_itemtype]) > 0 then //Got an item
		patch = ({
		v.cachePatch("W_ITURBO"), //Sneakers (Turbo)
		v.cachePatch("W_ITUREN"), //Rocket Shoes (Turbo Enforcer)
		v.cachePatch("W_ITAUTO"), //Invincability (Autodrive)
		v.cachePatch("W_ITMINE"), //Bananas (Mines)
		v.cachePatch("W_ITFIB"),  //FIB (WipeKart Exclusive)
		v.cachePatch("W_ITGREN"), //Orbinauts (Grenades)
		v.cachePatch("W_ITMISS"), //Jaws (Missiles)
		v.cachePatch("W_ITBOMB"), //Mines (Bomb)
		v.cachePatch("W_ITROCK"), //Ballhog (Rockets)
		v.cachePatch("W_INIRCK"), //SPB (Nitro Rocket)
		v.cachePatch("W_ITGROW"), //Grow (WipeKart Exclusive)
		v.cachePatch("W_IQUAKE"), //Shrink (Quake)
		v.cachePatch("W_ITSHIE"), //Thunder Shield (Shield)
		v.cachePatch("W_ISTEAL"), //Hyudoro (Stealth)
		v.cachePatch("W_ITPOGO"), //Pogo Springs (WipeKart Exclusive)
		v.cachePatch("W_ITPLAS"), //Kitchen Sink (Plasma)
		})[(p.kartstuff[k_itemtype])]
		v.draw(rx+x, ry+y, patch, flags)
		if tonumber(p.kartstuff[k_itemamount]) > 1
			v.drawString(rx+x, ry+y+32, p.kartstuff[k_itemamount], flags, "center")
		end
	elseif p.kartstuff[k_itemroulette] then //About to get an Item
		patch = ({
			v.cachePatch("W_ITURBO"),
			v.cachePatch("W_ITMINE"),
			v.cachePatch("W_ITGREN"),
			v.cachePatch("W_IQUAKE"),
			v.cachePatch("W_ITBOMB"),
			v.cachePatch("W_ITFIB"),
			v.cachePatch("W_ISTEAL"),
			v.cachePatch("W_ITSHIE"),
			v.cachePatch("W_ITAUTO"),
			v.cachePatch("W_ITMISS"),
			v.cachePatch("W_INIRCK"),
			v.cachePatch("W_ITROCK"),
			v.cachePatch("W_ITGROW"),
			v.cachePatch("W_ITPLAS"),
		})[(p.kartstuff[k_itemroulette]/3) % 13 + 1]
		v.draw(rx+x, ry+y, patch, flags)
	elseif p.kartstuff[k_eggmanexplode] then //Picked up a FIB!
		patch = v.cachePatch("W_ITFIB")
		v.draw(rx+x, ry+y, patch, flags)
		local eggtimer = p.kartstuff[k_eggmanexplode] / TICRATE
		if eggtimer > 3 then eggtimer = 3 end
		if p.kartstuff[k_eggmanexplode] % (6 + (eggtimer * 2)) < (3 + eggtimer) then
			patch = v.cachePatch("K_EGGN"..eggtimer)
			v.draw(rx+x-8, ry+y+3, patch, flags)
		end
	else
		v.draw(rx+x, ry+y, v.cachePatch("W_NOITEM"), flags)
	end
end

local basemaxspeed = {
	2519263, //Speed 1
	2568660, //Speed 2
	2618057, //Speed 3
	2667455, //Speed 4
	2716852, //Speed 5
	2766249, //Speed 6
	2815647, //Speed 7
	2865044, //Speed 8
	2914441  //Speed 9
}

local function wipespeed(speed)
	return FixedDiv(FixedMul(speed, 142371), mapheaderinfo[gamemap].mobj_scale)/(FRACUNIT/10)
end

local function wipehud_speed(v, p)
	-- random stuff for taking damage:
	local rx, ry = 0, 0
	if p.mo.zhudshake
		rx = N_RandomRange(-4, 4)
		ry = N_RandomRange(-4, 4)	-- shaker for damage
	end
	
	hud.disable("speedometer")
	local speed = p.speed
	local wspeed = wipespeed(speed)
	speed = FixedDiv(speed, mapheaderinfo[gamemap].mobj_scale)
	local speedmod = min(FixedDiv(speed, basemaxspeed[p.kartspeed]) / (FRACUNIT / 80), 100)
	local starty = 187
	local startx = 7
	v.draw(startx - 1 + rx, starty + 7 + ry, v.cachePatch("W_SPEED"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_HUDTRANS)
	local palette
	if p.speed < (mapheaderinfo[gamemap].mobj_scale * 10) then
		palette = 186
	elseif p.speed < (mapheaderinfo[gamemap].mobj_scale * 20) then
		palette = 103
	elseif speedmod < 80 then
		palette = 84 + ((speedmod - 30) / 5)
	elseif speedmod < 100 then
		palette = 132 - ((speedmod - 80) / 4)
	else
		palette = 126
	end
	if speedmod > 0 then
		v.drawFill(startx+rx, starty+ry, speedmod, 6, palette|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		for a = 1, 9
			if speedmod < (10 * a) then break end
			v.drawFill(startx + rx + (10*a), starty + ry - a, speedmod - (10*a), 1, palette|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		end
	end
	startx = 107
	starty = 162
	if p.mo.zhudshake
		rx = N_RandomRange(-4, 4)
		ry = N_RandomRange(-4, 4)	-- shaker for damage
	end
	drawWipeFontString(v, "WOFNT", wspeed, startx+rx, starty+ry, 14, V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
end

local function drawBPandScore(v, p, scoreonly, splitx, splity)
	local rx, ry = 0, 0
	if p.mo.zhudshake and not (p.pflags & PF_TIMEOVER) then
		rx = N_RandomRange(-4, 4)
		ry = N_RandomRange(-4, 4)	-- shaker for damage
	end
	local x = 160
	local y = 1
	x, y = splititemmod(x, y, splitx, splity)
	local flags = V_HUDTRANS
	if not splity then
		flags = $|V_SNAPTOTOP
	else
		if splity == 2 then
			flags = $|V_SNAPTOBOTTOM
		end
		if splitx ~= 2 then
			flags = $|V_SNAPTOLEFT
		end
	end
	
	if hud.enabled("gametypeinfo") then hud.disable("gametypeinfo") end
	
	if not scoreonly then
		local healthvalue = p.kartstuff[k_bumper]
		if healthvalue then 
			if p.currenthealth then healthvalue = p.currenthealth end
			if healthvalue > 99 then
				v.drawString(x+rx, y+ry, tostring(healthvalue), flags|V_GREENMAP, "center")				
			elseif healthvalue > 9 then 
				v.drawString(x+rx, y+ry, tostring(healthvalue).."B", flags|V_GREENMAP, "center")
			else
				v.drawString(x+rx, y+ry, tostring(healthvalue).."BP", flags|(((healthvalue > 1) or (leveltime%10 < 5)) and V_GREENMAP or V_REDMAP), "center")
			end
		else
			v.drawString(x+rx, y+ry, "OUT", flags|V_REDMAP, "center")
		end
	
		if p.mo.zhudshake
			rx = N_RandomRange(-4, 4)
			ry = N_RandomRange(-4, 4)	-- shaker for damage
		end
	else
		if (p.pflags & PF_TIMEOVER) then v.drawString(x, y, "OUT", flags|V_REDMAP, "center") end
	end
	
	flags = V_HUDTRANS
	x = 311
	if splitx then 
		x = 151 + (160 * (splitx - 1))
		if splitx == 2 then flags = $|V_SNAPTORIGHT end
	else
		flags = $|V_SNAPTORIGHT
	end
	if splity then
		y = 1 + (100 * (splity - 1))
		if splity == 1 then flags = $|V_SNAPTOTOP end
	else
		flags = $|V_SNAPTOTOP
	end
	y = $ + 6
	
	if not splitx then
		drawWipeFontString(v, "WOFNT", padTimerZero(p.marescore).." PTS", x+rx, y+ry, 14, flags)
		v.drawString(x+5+rx, 20+y+ry, tostring(p.score).." Server Pts", flags|V_BLUEMAP, "right")
	else
		drawWipeFontString(v, "WOFNT", padTimerZero(p.marescore).."P", x+rx, y+ry, 14, flags)
		v.drawString(x+5+rx, 20+y+ry, tostring(p.score).." S.Pts", flags|V_BLUEMAP, "right")
	end
end

local flash = {
	[0]	= 655360, //Fully transparent
	[1] = V_90TRANS,
	[2] = V_80TRANS,
	[3] = V_70TRANS,
	[4] = V_60TRANS,
	[5] = V_50TRANS,
	[6] = V_40TRANS,
	[7] = V_30TRANS,
	[8] = V_20TRANS,
	[9] = V_10TRANS,
	[10] = 0 //Fully opaque
}

local TIMEOVERLENGTH = 5 * TICRATE

addHook("MapLoad", do

	-- reenable hud items on map load
	hud.enable("time")
	hud.enable("gametypeinfo")
	hud.enable("position")
	hud.enable("item")
	hud.enable("speedometer")
	if goodver()
		hud.enable("freeplay")
	end
end)

hud.add(function(v, p, c)

	if hudstatus.value then
		//No Minimaps for you. Wipeout didn't have them, so WipeKart sure won't either
		if hud.enabled("minimap") then hud.disable("minimap") end
	
		//Splitscreen stuff
		local split
		local splitx
		local splity
		if splitscreen then
			split = true
			local n = c.pnum
			if not n return end	
			if splitscreen == 1 then
				splity = n
				splitx = nil
			else
				if n < 2 then splity = 1 else splity = 2 end
				if (n%2) == 1 then splitx = 1 else splitx = 2 end
			end
		else
			split = false
			splity = nil
			splitx = nil
		end
	
		//Zone Battle (lastWipeMode = 4) and Zone Attack (lastWipeMode = 5) have their own custom HUD
		if p.mo and not (p.pflags & PF_TIMEOVER) then 
			wipehud_item(v, p, splitx, splity)
			wipehud_time(v, p, splitx, splity)
			if not split then
				wipehud_speed(v, p)
			end
		
			//Race Modes has custom lap counters and (outside of Record Attack) custom placement counters
			if not (gametype & GT_MATCH) then
				wipehud_laps(v, p, split, splitx, splity)
				if not modeattacking then
					wipehud_place(v, p, splitx, splity)
				end
			end
		
			if (gametype & GT_MATCH) then
				drawBPandScore(v, p, false, splitx, splity)
			end
		elseif (gametype & GT_MATCH) and (p.pflags & PF_TIMEOVER) then
			drawBPandScore(v, p, true, splitx, splity)
		end
	else
		hud.enable("time")
		hud.enable("minimap")
		hud.enable("gametypeinfo")
		hud.enable("position")
		hud.enable("item")
		hud.enable("speedometer")
		if goodver()
			hud.enable("freeplay")
		end
	end
end)